Subject: bug#3972: 23.1.50; c-mode sets M-q to c-fill-paragraph

From: Stefan Monnier <[email-masked]>
Date: Thu, 30 Jul 2009 17:12:36 -0400

> I've just looked at fill-paragraph's source, and it looks like it's
> broken.  If it's called interactively, transient mark mode is enabled,
> the mark "is active", the region is non-zero length, and it's currently
> a full moon, each paragraph in the region is filled by calling
> fill-region, bypassing fill-paragraph-function.  Or maybe I've missed
> something.

That's a long standing design bug, indeed.

I think fill.el needs to introduce fill-forward-paragraph-function and
some kind of fill-region-as-paragraph-function (and obsolete
fill-paragraph-function).

Patches welcome,

        Stefan